/*****************************************************************************
 * Copyright (c) 2015 CEA LIST.
 *
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *  Francois Le Fevre francois.le-fevre@cea.fr  - Initial API and implementation
 *****************************************************************************/
package org.eclipse.papyrus.sysml14.service.types.matcher;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.emf.type.core.IElementMatcher;
import org.eclipse.papyrus.sysml14.constraintblocks.ConstraintBlock;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.util.UMLUtil;

/**
 * Test if type {@link Type} is a {@link ConstraintBlock}
 */
public class ConstraintPropertyMatcher implements IElementMatcher {

	public boolean matches(EObject eObject) {
		if (eObject instanceof Property) {
			Property property = (Property) eObject;
			Type type= property.getType();
			if(type!=null && UMLUtil.getStereotypeApplication(type, ConstraintBlock.class)!=null){
				return true;
			}
		}

		return false;
	}
}
